#!/usr/bin/env python3
import sys
import psycopg2
from psycopg2 import sql

# Database connection settings
host = "localhost"   # Database host
dbname = "rusproxy"  # Database name
user = "rusproxy"    # Database user
password = "mirabeth"  # Database password

# Connect to PostgreSQL database
try:
    conn = psycopg2.connect(host=host, dbname=dbname, user=user, password=password)
    cursor = conn.cursor()
except Exception as e:
    print(f"Error: Unable to connect to the database: {e}")
    sys.exit(1)

# Function to handle Squid authentication request
def authenticate_user(login, password):
    try:
        # SQL query to check if the login exists and balance > 0
        query = sql.SQL("""
            SELECT password, balance
            FROM proxy_users
            WHERE login = %s AND balance > 0.0
        """)
        
        cursor.execute(query, (login,))
        result = cursor.fetchone()

        if result:
            db_password, balance = result
            # Directly compare the password (as it's plain text)
            if password == db_password:
                return "OK"
            else:
                return "ERR"
        else:
            return "ERR"
    except Exception as e:
        print(f"Error: {e}")
        return "ERR"

# Main loop to handle Squid authentication requests
if __name__ == "__main__":
    for line in sys.stdin:
        line = line.strip()
        if line:
            login, password = line.split(' ', 1)
            result = authenticate_user(login, password)
            print(result)

# Close the database connection after the loop
cursor.close()
conn.close()

